<?php
require_once 'topic.php';

    class Category {
        private $id;
        private $name;
        const PATH = 'category';
        private $listTopics;
        private $topicsNumber;
        private $isExists = false;


        function __construct($id) {
            if (is_dir('database/'.Category::PATH.'/'.$id)) {
                $this->isExists = true;
                $this->id = $id;
                $this->name = new String(file_get_contents('database/'.Category::PATH.'/'.$this->id.'/name'));
            }
        }

        function getID() {
            return $this->id;
        }

        function isExists() {
            return $this->isExists;
        }

        function getName() {
            return $this->name;
        }

        function getTopicsNumber() {
            if ($this->isExists())
                return count(scandir('database/'.Category::PATH.'/'.$this->id.'/topic'));
            return -1;
        }

        function getListTopics() {
            if ($this->getTopicsNumber() > 0) {
                $list = scandir('database/'.Category::PATH.'/'.$this->id.'/topic');
                $listTopics[] = new Topic();
                for ($i = 0; $i < $this->getTopicsNumber(); $i++)
                    $listTopics[$i] = new Topic($list[$i]);
                return $listTopics;
            }
            return null;
        }

        function setName(String $name) {
            if ($this->isExists()) {
                Functional::writeFile('database/'.Category::PATH.'/'.$this->id.'/name', $name->getText(), 'w');
                return true;
            }
            return false;
        }

        static function createCategory(String $name, String $describe) {
            $id = count(scandir('database/'.Category::PATH.'/')) + 1;
            mkdir('database/'.Category::PATH.'/'.$id);
            mkdir('database/'.Category::PATH.'/'.$id.'/topic');
            Functional::writeFile('database/'.Category::PATH.'/'.$id.'/name', $name->getText(), 'w'); //Ghi name
            Functional::writeFile('database/'.Category::PATH.'/'.$id.'/describe', $describe->getText(), 'w'); //Ghi describe

        }
    }
?>